commit 04839796ae5e58e2bd35f803eb456912ca72bc3f
Author: Oto Šťáva <ostava@students.zcu.cz>
Date:   Mon May 24 09:55:03 2021 +0000

    Re #8906 - Server and client refactor

diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Client.cs b/deltarobot-vr/Assets/DeltaRobotVr/Client.cs
index 76f8889..8c7c315 100644
--- a/deltarobot-vr/Assets/DeltaRobotVr/Client.cs
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Client.cs
@@ -8,22 +8,10 @@ using UnityEngine;
 
 namespace DeltaRobotVr
 {
-    public readonly struct Single3
-    {
-        public float X { get; }
-        public float Y { get; }
-        public float Z { get; }
-
-        public Single3(float x, float y, float z)
-        {
-            X = x;
-            Y = y;
-            Z = z;
-        }
-
-        public override string ToString() => "Single3[ " + X + " " + Y + " " + Z + " ]";
-    }
-
+    
+    /// <summary>
+    /// Singleton class responsible for communication with the Deltarobot server.
+    /// </summary>
     public sealed class Client
     {
         // singleton instance
@@ -79,7 +67,7 @@ namespace DeltaRobotVr
         private long _curveCounter = 0;
 
         private volatile bool _isConnected;
-        private volatile string _eotMsg = string.Empty;
+        private volatile string _eotReason = string.Empty;
 
         private readonly object _reconnectTimeLock = new object();
         private DateTime _reconnectTime = DateTime.Now;
@@ -92,6 +80,9 @@ namespace DeltaRobotVr
         {
         }
 
+        /// <summary>
+        /// Starts the client thread and connects to the server.
+        /// </summary>
         public void Start()
         {
             IsRunning = true;
@@ -99,6 +90,9 @@ namespace DeltaRobotVr
             _thread.Start();
         }
 
+        /// <summary>
+        /// Gracefully stops the client thread. Blocks until the thread actually stops.
+        /// </summary>
         public void Stop()
         {
             IsRunning = false;
@@ -109,18 +103,27 @@ namespace DeltaRobotVr
             }
         }
 
-        public string EotMsg
+        /// <summary>
+        /// Contains a reason received in an end-of-transmission message.
+        /// </summary>
+        public string EotReason
         {
-            get => _eotMsg;
-            private set => _eotMsg = value;
+            get => _eotReason;
+            private set => _eotReason = value;
         }
 
+        /// <summary>
+        /// Whether the client is currently maintaining an active connection to the server.
+        /// </summary>
         public bool IsConnected
         {
             get => _isConnected;
             private set => _isConnected = value;
         }
 
+        /// <summary>
+        /// Current position of the actuator (in server's world space).
+        /// </summary>
         public Single3 ActuatorPosition
         {
             get
@@ -139,7 +142,10 @@ namespace DeltaRobotVr
             } 
         }
 
-        public Single3 CurrentDirectionVector
+        /// <summary>
+        /// The actual direction the actuator is currently moving in.
+        /// </summary>
+        public Single3 ActualDirectionVector
         {
             get
             {
@@ -157,7 +163,10 @@ namespace DeltaRobotVr
             }
         }
 
-        public Single3 DesiredDirectionVector
+        /// <summary>
+        /// The target direction the actuator should be moving in so that it draws the curve.
+        /// </summary>
+        public Single3 TargetDirectionVector
         {
             get
             {
@@ -175,6 +184,9 @@ namespace DeltaRobotVr
             }
         }
 
+        /// <summary>
+        /// The current exercise curve.
+        /// </summary>
         public Single3[] Curve
         {
             get
@@ -193,6 +205,10 @@ namespace DeltaRobotVr
             }
         }
 
+        /// <summary>
+        /// A counter used to determine whether the curve has changed. The curve remains the same while the counter is
+        /// the same.
+        /// </summary>
         public long CurveCounter
         {
             get
@@ -211,6 +227,9 @@ namespace DeltaRobotVr
             }
         }
 
+        /// <summary>
+        /// Whether the client thread should keep on reading data from the server.
+        /// </summary>
         public bool IsRunning
         {
             get {
@@ -228,6 +247,9 @@ namespace DeltaRobotVr
             }
         }
 
+        /// <summary>
+        /// The time at which the client will attempt to reconnect to the server again.
+        /// </summary>
         public DateTime ReconnectTime
         {
             get
@@ -246,6 +268,9 @@ namespace DeltaRobotVr
             }
         }
 
+        /// <summary>
+        /// The client thread function.
+        /// </summary>
         private void ThreadProcedure()
         {
             while (IsRunning)
@@ -315,13 +340,13 @@ namespace DeltaRobotVr
                     ProcessEot(reader);
                     break;
                 case CurrentActuatorPositionId:
-                    ProcessCurrentActuatorPosition(reader);
+                    ProcessActuatorPosition(reader);
                     break;
                 case CurrentDirectionVectorId:
-                    ProcessCurrentDirectionVector(reader);
+                    ProcessActualDirectionVector(reader);
                     break;
                 case DesiredDirectionVectorId:
-                    ProcessDesiredDirectionVector(reader);
+                    ProcessTargetDirectionVector(reader);
                     break;
                 case CurveId:
                     ProcessCurve(reader);
@@ -394,7 +419,7 @@ namespace DeltaRobotVr
             reader.ReadBytes((int) numberOfBytes);
         }
 
-        private void ProcessCurrentActuatorPosition(BinaryReader reader)
+        private void ProcessActuatorPosition(BinaryReader reader)
         {
             var x = reader.ReadSingle();
             var y = reader.ReadSingle();
@@ -404,24 +429,24 @@ namespace DeltaRobotVr
             ActuatorPosition = new Single3(x, y, z);
         }
 
-        private void ProcessCurrentDirectionVector(BinaryReader reader)
+        private void ProcessActualDirectionVector(BinaryReader reader)
         {
             var x = reader.ReadSingle();
             var y = reader.ReadSingle();
             var z = reader.ReadSingle();
             reader.ReadSingle(); // skip unused
 
-            CurrentDirectionVector = new Single3(x, y, z);
+            ActualDirectionVector = new Single3(x, y, z);
         }
 
-        private void ProcessDesiredDirectionVector(BinaryReader reader)
+        private void ProcessTargetDirectionVector(BinaryReader reader)
         {
             var x = reader.ReadSingle();
             var y = reader.ReadSingle();
             var z = reader.ReadSingle();
             reader.ReadSingle(); // skip unused
 
-            DesiredDirectionVector = new Single3(x, y, z);
+            TargetDirectionVector = new Single3(x, y, z);
         }
 
         private void ProcessCurve(BinaryReader reader)
@@ -449,7 +474,7 @@ namespace DeltaRobotVr
         {
             UInt32 numberOfBytes = reader.ReadUInt32();
             Byte[] buffer = reader.ReadBytes((int) numberOfBytes);
-            EotMsg = Encoding.ASCII.GetString(buffer);
+            EotReason = Encoding.ASCII.GetString(buffer);
             IsConnected = false;
         }
 
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components.meta b/deltarobot-vr/Assets/DeltaRobotVr/Components.meta
new file mode 100644
index 0000000..12ee354
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components.meta
@@ -0,0 +1,3 @@
+﻿fileFormatVersion: 2
+guid: fc6bedc3421d40129835f279dbc661e2
+timeCreated: 1621693639
\ No newline at end of file
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/AbstractArrow.cs b/deltarobot-vr/Assets/DeltaRobotVr/Components/AbstractArrow.cs
new file mode 100644
index 0000000..1ea67f7
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/AbstractArrow.cs
@@ -0,0 +1,29 @@
+using UnityEngine;
+
+namespace DeltaRobotVr.Components
+{
+    /// <summary>
+    /// A generic implementation of vector visualization. The vector is determined by the <c>GetVector</c> method.
+    /// </summary>
+    public abstract class AbstractArrow : MonoBehaviour
+    {
+        public float lengthMultiplier = 2;
+
+        void Update()
+        {
+            if (Client.Instance.IsConnected)
+            {
+                Vector3 v = Single3Utils.ToVector3(GetVector());
+                
+                var t = transform;
+                t.rotation = Quaternion.FromToRotation(Vector3.forward, v);
+                t.localScale = new Vector3(1, 1, v.magnitude * lengthMultiplier);
+            }
+        }
+
+        /// <summary>
+        /// Gets the vector that this component renders.
+        /// </summary>
+        protected abstract Single3 GetVector();
+    }
+}
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/AbstractArrow.cs.meta b/deltarobot-vr/Assets/DeltaRobotVr/Components/AbstractArrow.cs.meta
new file mode 100644
index 0000000..d7f42bb
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/AbstractArrow.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: e8091905fe5149d40a4fb2711bb82b8b
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/ActualDirectionArrow.cs b/deltarobot-vr/Assets/DeltaRobotVr/Components/ActualDirectionArrow.cs
new file mode 100644
index 0000000..2577d21
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/ActualDirectionArrow.cs
@@ -0,0 +1,11 @@
+namespace DeltaRobotVr.Components
+{
+    
+    /// <summary>
+    /// This arrow visualizes the actual direction the actuator is currently moving in.
+    /// </summary>
+    public class ActualDirectionArrow : AbstractArrow
+    {
+        protected override Single3 GetVector() => Client.Instance.ActualDirectionVector;
+    }
+}
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/ActualDirectionArrow.cs.meta b/deltarobot-vr/Assets/DeltaRobotVr/Components/ActualDirectionArrow.cs.meta
new file mode 100644
index 0000000..7ed64b3
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/ActualDirectionArrow.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 7d92319639667d643a9722c4c835a70b
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/Actuator.cs b/deltarobot-vr/Assets/DeltaRobotVr/Components/Actuator.cs
new file mode 100644
index 0000000..ff0af5e
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/Actuator.cs
@@ -0,0 +1,26 @@
+using UnityEngine;
+
+namespace DeltaRobotVr.Components
+{
+    public class Actuator : MonoBehaviour
+    {
+        public const float LerpParam = 0.5f;
+        
+        private Transform _transform;
+    
+        void Start()
+        {
+            _transform = GetComponent<Transform>();
+        }
+    
+        void Update()
+        {
+            if (Client.Instance.IsConnected)
+            {
+                var actPosition = Client.Instance.ActuatorPosition;
+                var newPosition = Single3Utils.ToVector3(actPosition.X, actPosition.Y, actPosition.Z);
+                _transform.position = Vector3.Lerp(_transform.position, newPosition, LerpParam);
+            }
+        }
+    }
+}
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/Actuator.cs.meta b/deltarobot-vr/Assets/DeltaRobotVr/Components/Actuator.cs.meta
new file mode 100644
index 0000000..6bdad38
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/Actuator.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: cfafba4e0e8b6e0adb6dda9dbc5076f8
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs b/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs
new file mode 100644
index 0000000..5f9756a
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs
@@ -0,0 +1,29 @@
+using UnityEngine;
+
+namespace DeltaRobotVr.Components
+{
+    public class Curve : MonoBehaviour
+    {
+        private long _currentCounter;
+        private LineRenderer _lineRenderer;
+        
+        void Start()
+        {
+            _currentCounter = Client.Instance.CurveCounter;
+            _lineRenderer = GetComponent<LineRenderer>();
+        }
+   
+        void Update()
+        {
+            if (Client.Instance.IsConnected)
+            {
+                var counter = Client.Instance.CurveCounter;
+                if(counter != _currentCounter && Client.Instance.Curve != null)
+                {
+                    _lineRenderer.positionCount = Client.Instance.Curve.Length;
+                    _lineRenderer.SetPositions(Single3Utils.ToVector3(Client.Instance.Curve));
+                }
+            }
+        }
+    }
+}
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs.meta b/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs.meta
new file mode 100644
index 0000000..742aa0a
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: bb50b983128c52b48ae66147e4978d5f
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/StatusDisplay.cs b/deltarobot-vr/Assets/DeltaRobotVr/Components/StatusDisplay.cs
new file mode 100644
index 0000000..89afec9
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/StatusDisplay.cs
@@ -0,0 +1,38 @@
+using System.Collections;
+using System.Collections.Generic;
+using UnityEngine;
+using UnityEngine.UI;
+using DeltaRobotVr;
+
+public class StatusDisplay : MonoBehaviour
+{
+    private const string STATUS = "Status:\n";
+    private const string CONNECTED = "<color=green>Connected</color>";
+    private const string CONNECTING = "<color=red>Connecting...</color>";
+    private Text _textComp;
+    // Start is called before the first frame update
+    void Start()
+    {
+        _textComp = GetComponent<Text>();
+    }
+
+    // Update is called once per frame
+    void Update()
+    {
+        if (Client.Instance.IsConnected)
+        {
+            _textComp.text = STATUS + CONNECTED;
+        }
+        else
+        {
+            if (Client.Instance.EotReason.Length == 0)
+            {
+                _textComp.text = STATUS + CONNECTING;
+            }
+            else
+            {
+                _textComp.text = STATUS + CONNECTING + "\n" + Client.Instance.EotReason;
+            }
+        }
+    }
+}
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/StatusDisplay.cs.meta b/deltarobot-vr/Assets/DeltaRobotVr/Components/StatusDisplay.cs.meta
new file mode 100644
index 0000000..d56b562
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/StatusDisplay.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 3dfc99055443ed24597abf07afc16604
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/TargetDirectionArrow.cs b/deltarobot-vr/Assets/DeltaRobotVr/Components/TargetDirectionArrow.cs
new file mode 100644
index 0000000..72778c8
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/TargetDirectionArrow.cs
@@ -0,0 +1,11 @@
+namespace DeltaRobotVr.Components
+{
+    
+    /// <summary>
+    /// This arrow visualizes the target direction the actuator should be moving in, in order to draw the curve.
+    /// </summary>
+    public class TargetDirectionArrow : AbstractArrow
+    {
+        protected override Single3 GetVector() => Client.Instance.TargetDirectionVector;
+    }
+}
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/TargetDirectionArrow.cs.meta b/deltarobot-vr/Assets/DeltaRobotVr/Components/TargetDirectionArrow.cs.meta
new file mode 100644
index 0000000..cdd6e2a
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/TargetDirectionArrow.cs.meta
@@ -0,0 +1,11 @@
+fileFormatVersion: 2
+guid: 0405dab141f621d4aae1935de042ed9d
+MonoImporter:
+  externalObjects: {}
+  serializedVersion: 2
+  defaultReferences: []
+  executionOrder: 0
+  icon: {instanceID: 0}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/MainScript.cs b/deltarobot-vr/Assets/DeltaRobotVr/MainScript.cs
index 418cf3d..f55bbac 100644
--- a/deltarobot-vr/Assets/DeltaRobotVr/MainScript.cs
+++ b/deltarobot-vr/Assets/DeltaRobotVr/MainScript.cs
@@ -1,20 +1,23 @@
-using System;
-using UnityEngine;
-using UnityEngine.SceneManagement;
-
-namespace DeltaRobotVr
-{
-    public class MainScript : MonoBehaviour
-    {
-        private void Start()
-        {
-            SceneManager.LoadScene("BasicRoomScene", LoadSceneMode.Additive);
-            Client.Instance.Start();
-        }
-
-        private void OnDestroy()
-        {
-            Client.Instance.Stop();
-        }
-    }
+using UnityEngine;
+using UnityEngine.SceneManagement;
+
+namespace DeltaRobotVr
+{
+    
+    /// <summary>
+    /// Global script for the main scene.
+    /// </summary>
+    public class MainScript : MonoBehaviour
+    {
+        private void Start()
+        {
+            SceneManager.LoadScene("BasicRoomScene", LoadSceneMode.Additive);
+            Client.Instance.Start();
+        }
+
+        private void OnDestroy()
+        {
+            Client.Instance.Stop();
+        }
+    }
 }
\ No newline at end of file
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Single3.cs b/deltarobot-vr/Assets/DeltaRobotVr/Single3.cs
new file mode 100644
index 0000000..61b1b0c
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Single3.cs
@@ -0,0 +1,22 @@
+namespace DeltaRobotVr
+{
+    
+    /// <summary>
+    /// A simple 3D float vector.
+    /// </summary>
+    public readonly struct Single3
+    {
+        public float X { get; }
+        public float Y { get; }
+        public float Z { get; }
+
+        public Single3(float x, float y, float z)
+        {
+            X = x;
+            Y = y;
+            Z = z;
+        }
+
+        public override string ToString() => "Single3[ " + X + " " + Y + " " + Z + " ]";
+    }
+}
\ No newline at end of file
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Single3.cs.meta b/deltarobot-vr/Assets/DeltaRobotVr/Single3.cs.meta
new file mode 100644
index 0000000..680ce3d
--- /dev/null
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Single3.cs.meta
@@ -0,0 +1,3 @@
+﻿fileFormatVersion: 2
+guid: 5e77e12132de42cdb006c02000deb1b1
+timeCreated: 1621783853
\ No newline at end of file
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Single3Utils.cs b/deltarobot-vr/Assets/DeltaRobotVr/Single3Utils.cs
index 28b6175..38c452c 100644
--- a/deltarobot-vr/Assets/DeltaRobotVr/Single3Utils.cs
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Single3Utils.cs
@@ -2,6 +2,10 @@ using UnityEngine;
 
 namespace DeltaRobotVr
 {
+    
+    /// <summary>
+    /// Utilities for the <c>Single3</c> struct.
+    /// </summary>
     public class Single3Utils
     {
         public const float PositionScale = 0.001f;
diff --git a/deltarobot-vr/Assets/Materials/ActualDirectionMaterial.mat b/deltarobot-vr/Assets/Materials/ActualDirectionMaterial.mat
new file mode 100644
index 0000000..9b95e56
--- /dev/null
+++ b/deltarobot-vr/Assets/Materials/ActualDirectionMaterial.mat
@@ -0,0 +1,78 @@
+%YAML 1.1
+%TAG !u! tag:unity3d.com,2011:
+--- !u!21 &2100000
+Material:
+  serializedVersion: 6
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_Name: ActualDirectionMaterial
+  m_Shader: {fileID: 46, guid: 0000000000000000f000000000000000, type: 0}
+  m_ShaderKeywords: 
+  m_LightmapFlags: 4
+  m_EnableInstancingVariants: 0
+  m_DoubleSidedGI: 0
+  m_CustomRenderQueue: -1
+  stringTagMap: {}
+  disabledShaderPasses: []
+  m_SavedProperties:
+    serializedVersion: 3
+    m_TexEnvs:
+    - _BumpMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailAlbedoMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailMask:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailNormalMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _EmissionMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _MainTex:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _MetallicGlossMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _OcclusionMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _ParallaxMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    m_Floats:
+    - _BumpScale: 1
+    - _Cutoff: 0.5
+    - _DetailNormalMapScale: 1
+    - _DstBlend: 0
+    - _GlossMapScale: 1
+    - _Glossiness: 0.5
+    - _GlossyReflections: 1
+    - _Metallic: 0
+    - _Mode: 0
+    - _OcclusionStrength: 1
+    - _Parallax: 0.02
+    - _SmoothnessTextureChannel: 0
+    - _SpecularHighlights: 1
+    - _SrcBlend: 1
+    - _UVSec: 0
+    - _ZWrite: 1
+    m_Colors:
+    - _Color: {r: 1, g: 0, b: 0, a: 1}
+    - _EmissionColor: {r: 0, g: 0, b: 0, a: 1}
+  m_BuildTextureStacks: []
diff --git a/deltarobot-vr/Assets/Materials/ActualDirectionMaterial.mat.meta b/deltarobot-vr/Assets/Materials/ActualDirectionMaterial.mat.meta
new file mode 100644
index 0000000..cbfd20e
--- /dev/null
+++ b/deltarobot-vr/Assets/Materials/ActualDirectionMaterial.mat.meta
@@ -0,0 +1,8 @@
+fileFormatVersion: 2
+guid: 306843c96e6ccc5e292e116d1d3418a6
+NativeFormatImporter:
+  externalObjects: {}
+  mainObjectFileID: 2100000
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat b/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat
new file mode 100644
index 0000000..cb1df02
--- /dev/null
+++ b/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat
@@ -0,0 +1,78 @@
+%YAML 1.1
+%TAG !u! tag:unity3d.com,2011:
+--- !u!21 &2100000
+Material:
+  serializedVersion: 6
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_Name: ActuatorMaterial
+  m_Shader: {fileID: 46, guid: 0000000000000000f000000000000000, type: 0}
+  m_ShaderKeywords: 
+  m_LightmapFlags: 4
+  m_EnableInstancingVariants: 0
+  m_DoubleSidedGI: 0
+  m_CustomRenderQueue: -1
+  stringTagMap: {}
+  disabledShaderPasses: []
+  m_SavedProperties:
+    serializedVersion: 3
+    m_TexEnvs:
+    - _BumpMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailAlbedoMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailMask:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailNormalMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _EmissionMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _MainTex:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _MetallicGlossMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _OcclusionMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _ParallaxMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    m_Floats:
+    - _BumpScale: 1
+    - _Cutoff: 0.5
+    - _DetailNormalMapScale: 1
+    - _DstBlend: 0
+    - _GlossMapScale: 1
+    - _Glossiness: 0.5
+    - _GlossyReflections: 1
+    - _Metallic: 0
+    - _Mode: 0
+    - _OcclusionStrength: 1
+    - _Parallax: 0.02
+    - _SmoothnessTextureChannel: 0
+    - _SpecularHighlights: 1
+    - _SrcBlend: 1
+    - _UVSec: 0
+    - _ZWrite: 1
+    m_Colors:
+    - _Color: {r: 0, g: 0.61987686, b: 1, a: 1}
+    - _EmissionColor: {r: 0, g: 0, b: 0, a: 1}
+  m_BuildTextureStacks: []
diff --git a/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat.meta b/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat.meta
new file mode 100644
index 0000000..c735799
--- /dev/null
+++ b/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat.meta
@@ -0,0 +1,8 @@
+fileFormatVersion: 2
+guid: c14ddb25b53d5c1d38abd988a0ff268e
+NativeFormatImporter:
+  externalObjects: {}
+  mainObjectFileID: 2100000
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/Materials/CurveMaterial.mat b/deltarobot-vr/Assets/Materials/CurveMaterial.mat
new file mode 100644
index 0000000..a374faa
--- /dev/null
+++ b/deltarobot-vr/Assets/Materials/CurveMaterial.mat
@@ -0,0 +1,78 @@
+%YAML 1.1
+%TAG !u! tag:unity3d.com,2011:
+--- !u!21 &2100000
+Material:
+  serializedVersion: 6
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_Name: CurveMaterial
+  m_Shader: {fileID: 46, guid: 0000000000000000f000000000000000, type: 0}
+  m_ShaderKeywords: 
+  m_LightmapFlags: 4
+  m_EnableInstancingVariants: 0
+  m_DoubleSidedGI: 0
+  m_CustomRenderQueue: -1
+  stringTagMap: {}
+  disabledShaderPasses: []
+  m_SavedProperties:
+    serializedVersion: 3
+    m_TexEnvs:
+    - _BumpMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailAlbedoMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailMask:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailNormalMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _EmissionMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _MainTex:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _MetallicGlossMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _OcclusionMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _ParallaxMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    m_Floats:
+    - _BumpScale: 1
+    - _Cutoff: 0.5
+    - _DetailNormalMapScale: 1
+    - _DstBlend: 0
+    - _GlossMapScale: 1
+    - _Glossiness: 0.5
+    - _GlossyReflections: 1
+    - _Metallic: 0
+    - _Mode: 0
+    - _OcclusionStrength: 1
+    - _Parallax: 0.02
+    - _SmoothnessTextureChannel: 0
+    - _SpecularHighlights: 1
+    - _SrcBlend: 1
+    - _UVSec: 0
+    - _ZWrite: 1
+    m_Colors:
+    - _Color: {r: 1, g: 1, b: 0, a: 1}
+    - _EmissionColor: {r: 0, g: 0, b: 0, a: 1}
+  m_BuildTextureStacks: []
diff --git a/deltarobot-vr/Assets/Materials/CurveMaterial.mat.meta b/deltarobot-vr/Assets/Materials/CurveMaterial.mat.meta
new file mode 100644
index 0000000..92de289
--- /dev/null
+++ b/deltarobot-vr/Assets/Materials/CurveMaterial.mat.meta
@@ -0,0 +1,8 @@
+fileFormatVersion: 2
+guid: 4fccf519985fbac4cafe474b1888cf3c
+NativeFormatImporter:
+  externalObjects: {}
+  mainObjectFileID: 2100000
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/Materials/TargetDirectionMaterial.mat b/deltarobot-vr/Assets/Materials/TargetDirectionMaterial.mat
new file mode 100644
index 0000000..ce71802
--- /dev/null
+++ b/deltarobot-vr/Assets/Materials/TargetDirectionMaterial.mat
@@ -0,0 +1,78 @@
+%YAML 1.1
+%TAG !u! tag:unity3d.com,2011:
+--- !u!21 &2100000
+Material:
+  serializedVersion: 6
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_Name: TargetDirectionMaterial
+  m_Shader: {fileID: 46, guid: 0000000000000000f000000000000000, type: 0}
+  m_ShaderKeywords: 
+  m_LightmapFlags: 4
+  m_EnableInstancingVariants: 0
+  m_DoubleSidedGI: 0
+  m_CustomRenderQueue: -1
+  stringTagMap: {}
+  disabledShaderPasses: []
+  m_SavedProperties:
+    serializedVersion: 3
+    m_TexEnvs:
+    - _BumpMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailAlbedoMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailMask:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _DetailNormalMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _EmissionMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _MainTex:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _MetallicGlossMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _OcclusionMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    - _ParallaxMap:
+        m_Texture: {fileID: 0}
+        m_Scale: {x: 1, y: 1}
+        m_Offset: {x: 0, y: 0}
+    m_Floats:
+    - _BumpScale: 1
+    - _Cutoff: 0.5
+    - _DetailNormalMapScale: 1
+    - _DstBlend: 0
+    - _GlossMapScale: 1
+    - _Glossiness: 0.5
+    - _GlossyReflections: 1
+    - _Metallic: 0
+    - _Mode: 0
+    - _OcclusionStrength: 1
+    - _Parallax: 0.02
+    - _SmoothnessTextureChannel: 0
+    - _SpecularHighlights: 1
+    - _SrcBlend: 1
+    - _UVSec: 0
+    - _ZWrite: 1
+    m_Colors:
+    - _Color: {r: 0, g: 1, b: 0, a: 1}
+    - _EmissionColor: {r: 0, g: 0, b: 0, a: 1}
+  m_BuildTextureStacks: []
diff --git a/deltarobot-vr/Assets/Materials/TargetDirectionMaterial.mat.meta b/deltarobot-vr/Assets/Materials/TargetDirectionMaterial.mat.meta
new file mode 100644
index 0000000..5308d3d
--- /dev/null
+++ b/deltarobot-vr/Assets/Materials/TargetDirectionMaterial.mat.meta
@@ -0,0 +1,8 @@
+fileFormatVersion: 2
+guid: e2bc3c456e5936babaf6b4ec7434e213
+NativeFormatImporter:
+  externalObjects: {}
+  mainObjectFileID: 2100000
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
diff --git a/deltarobot-vr/Assets/Meshes.meta b/deltarobot-vr/Assets/Meshes.meta
new file mode 100644
index 0000000..52101fa
--- /dev/null
+++ b/deltarobot-vr/Assets/Meshes.meta
@@ -0,0 +1,8 @@
+fileFormatVersion: 2
+guid: 14a478c570286e138b01eab3201294bb
+folderAsset: yes
+DefaultImporter:
+  externalObjects: {}
+  userData: 
+  assetBundleName: 
+  assetBundleVariant: 
